# Grok Voice API

> பதிவுசெய்யப்பட்ட ஆடியோ கிளிப்பைக் கேட்டு, பேச்சுடன் கூடிய பதிலையும் உரைமாற்றத்தையும் வழங்கும் குரல் ஏஜென்ட்

`audio_url` மூலம் ஒரு பதிவை அனுப்பினால், முகவர் பேச்சு ஆடியோவில் பதிலளிக்கிறார்; அது 24 kHz ஒற்றை ஒலி WAV ஆகவும், அதன் கால அளவு மற்றும் கிடைக்கும்போது உரைமாற்றத்துடனும் வழங்கப்படுகிறது. விருப்ப `prompt` (20000 எழுத்துகள் வரை) நபர்தன்மை மற்றும் சூழலை அமைக்கிறது; `voice` உள்ளமைக்கப்பட்ட குரலைத் தேர்ந்தெடுக்கிறது. `tools` பொருள் வலைத் தேடல், X தேடல் அல்லது தொலைநிலை MCP சேவையகங்களை இயக்கலாம்; இவை அனைத்தும் இயல்புநிலையாக முடக்கப்பட்டுள்ளன.

- Model id: `xai/grok-voice`
- Made by: xAI
- Category: Audio
- Output: audio
- Charged by usage (up to $1.494 per run, typical $0.006; the rest of the hold is refunded): $0.00083 / second of the voice session (cheapest run $0.006 (6 API credits))
- Run: `POST https://api.doitong.com/v1/run/xai/grok-voice`
- Quote: `POST https://api.doitong.com/v1/quote/xai/grok-voice`
- Docs page: https://doitong.com/ta/developers/models/xai/grok-voice

## Pricing

Price: **$0.00083 / second of the voice session**. Charged by actual usage at $0.00083 / second of the voice session: up to $1.494 per run (the quote gives the maximum for your input), the rest is refunded automatically after the run. A typical run costs $0.006.

The full example input below holds up to $1.494 = 1494 API credits (up to 1800 s of voice session × $0.00083) when it starts; a typical run costs $0.006 (6 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). This model is charged by usage: `POST https://api.doitong.com/v1/quote/xai/grok-voice` with the same JSON body returns the most the run can cost for that input (`credits`, debited when the run starts); after the run you pay the usage the model reports and the rest is refunded automatically. An input whose maximum would exceed the per-run limit is refused with 422. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `audio_url` | `audio` | string (audio URL) | yes |  |  | பயனரின் பேச்சுக்கான ஆடியோ URL; 10 நிமிடம் மற்றும் 50 MB வரை மட்டுப்படுத்தப்பட்டது. பொதுவாகப் பயன்படுத்தப்படும் பெரும்பாலான ஆடியோ வடிவங்களை வழங்கலாம்; Grok ஆடியோவைப் பெறுவதற்கு முன், அது 24 kHz-இல் 16-bit மாதிரிகளைக் கொண்ட mono PCM ஆக மாற்றப்படும். முகவர் பதிவுக்கு பேச்சு மூலம் பதிலளிக்கும். |
| `prompt` |  | string \| null | no |  | ≤ 20000 characters | உரையாடல் சூழலை வழங்கி, Grok-ன் இயல்புநிலை persona-வுக்குப் பதிலாக persona-வை வரையறுக்கும் விருப்பமான system instructions; இவற்றைத் தவிர்த்தால் இயல்புநிலை persona தொடரும். |
| `voice` |  | enum (string) \| null | no |  | `carina`, `zagan`, `helix`, `orion`, `luna`, `iris`, `altair`, `zenith`, `perseus`, `helios`, `lux`, `kepler`, `rigel`, `cosmo`, `celeste`, `ursa`, `sirius`, `lumen`, `castor`, `naksh`, `atlas`, `aurora`, `liora`, `ara`, `eve`, `leo`, `rex`, `sal` | முகவரின் பதிலுக்காக Grok-ன் இயல்புநிலை குரலை மாற்ற, உள்ளமைக்கப்பட்ட xAI குரலைத் தேர்ந்தெடுக்கவும்; இதை அமைக்காமல் விட்டால் இயல்புநிலை குரல் தொடரும். |
| `tools` |  | object {mcp_servers, web_search, x_search} | no | `{"mcp_servers":[],"web_search":{"enabled":false},"x_search":{"enabled":false}}` |  | சர்வர்-பக்கப் பயன்பாட்டிற்கான முகவர் கருவி உள்ளமைவு; ZDR காரணமாக typed configuration-இலிருந்து file_search/collections விலக்கப்பட்டுள்ளன. அனைத்து கருவிகளும் முதலில் முடக்கப்பட்டிருக்கும்; ஆதரிக்கப்படும் விருப்பங்களில் remote MCP tools, web tools மற்றும் X tools அடங்கும். |
| `tools.mcp_servers` |  | array of object {allowed_tools, authorization, enabled, headers, server_description, server_label, server_url} | no |  |  | கருவி செயல்பாட்டிற்காக மாதிரி வழங்குநர் இணையும் Remote MCP servers. |
| `tools.mcp_servers[].allowed_tools` |  | array of string \| null | no |  | ≥ 1 items | இந்த சர்வர் வெளிப்படுத்தும் கருவிப் பெயர்களைக் குறிப்பிடும் விருப்பமான பட்டியல். |
| `tools.mcp_servers[].authorization` |  | string \| null | no |  |  | மாதிரி வழங்குநருக்கு மட்டுமே அனுப்பப்படும் உணர்திறன் மிக்க authorization மதிப்பு. |
| `tools.mcp_servers[].enabled` |  | boolean | no | `true` |  | சர்வர் சேர்க்கைக் கொடி; false என்றால் சர்வர் விலக்கப்படும். |
| `tools.mcp_servers[].headers` |  | object \| null | no |  |  | MCP கோரிக்கைகளுக்கான உணர்திறன் மிக்க headers; மாதிரி வழங்குநருக்கு மட்டுமே அனுப்பப்படும். |
| `tools.mcp_servers[].server_description` |  | string \| null | no |  | ≤ 2000 characters | இந்த சர்வர் வழங்கும் திறன்களைச் சுருக்கமாக விளக்கும் விளக்கம். |
| `tools.mcp_servers[].server_label` |  | string | yes |  | 1 – 128 characters | மாதிரி வழங்குநர் அதன் கருவிகளை அடையாளம் காணவும், அவற்றின் பெயர்களுக்கு முன்னொட்டு சேர்க்கவும் பயன்படுத்தும் சர்வர் label. |
| `tools.mcp_servers[].server_url` |  | string | yes |  | ≥ 1 characters | Streaming HTTP/SSE transports மூலம் Grok தொலைவிலிருந்து இணையும் MCP server-க்காக caller வழங்கும் HTTP(S) முகவரி. |
| `tools.web_search` |  | object {allowed_domains, enable_image_understanding, enabled, excluded_domains, location} | no | `{"allowed_domains":null,"enable_image_understanding":null,"enabled":false,"excluded_domains":null,"location":null}` |  | மாதிரி வழங்குநர் நிர்வகிக்கும் web search; enabled true ஆக இல்லாவிட்டால் முடக்கப்பட்டிருக்கும். |
| `tools.web_search.allowed_domains` |  | array of string \| null | no |  | 1 – 5 items | தேடல் முடிவுகளுக்கான domain கட்டுப்பாடு: protocol-களும் paths-உம் இல்லாமல் அதிகபட்சம் ஐந்து domains குறிப்பிடவும். |
| `tools.web_search.enable_image_understanding` |  | boolean \| null | no |  |  | web searches மூலம் கண்டறியப்பட்ட படங்களை ஆய்வு செய்ய முகவருக்கான அனுமதி. |
| `tools.web_search.enabled` |  | boolean | no | `false` |  | முகவருக்கான web-search அணுகல்: true என்பது session.tools-இல் web_search-ஐச் சேர்த்து web searches-ஐ அனுமதிக்கும்; இயல்புநிலை அதை முடக்கி வைக்கும். |
| `tools.web_search.excluded_domains` |  | array of string \| null | no |  | 1 – 5 items | தேடல் முடிவுகளில் இருந்து விலக்க வேண்டிய domains; protocol-களும் paths-உம் இல்லாமல் அதிகபட்சம் ஐந்து பதிவுகள். |
| `tools.web_search.location` |  | object {city, country, region, timezone} \| null | no |  |  | தேடல் முடிவுகளைப் புவியியல் அடிப்படையில்த் தனிப்பயனாக்குவதற்கான விருப்பமான இருப்பிடம். |
| `tools.x_search` |  | object {allowed_x_handles, enable_image_understanding, enable_video_understanding, enabled, excluded_x_handles, from_date, to_date} | no | `{"allowed_x_handles":null,"enable_image_understanding":null,"enable_video_understanding":null,"enabled":false,"excluded_x_handles":null,"from_date":null,"to_date":null}` |  | மாதிரி வழங்குநர் நிர்வகிக்கும் X search; enabled true ஆக இல்லாவிட்டால் முடக்கப்பட்டிருக்கும். |
| `tools.x_search.allowed_x_handles` |  | array of string \| null | no |  | 1 – 20 items | முடிவுகளில் இடுகைகள் தோன்றக்கூடிய X handles; அதிகபட்சம் 20 handles. |
| `tools.x_search.enable_image_understanding` |  | boolean \| null | no |  |  | X-இல் கண்டறியப்பட்ட படங்களை ஆய்வு செய்ய முகவருக்கான அனுமதி. |
| `tools.x_search.enable_video_understanding` |  | boolean \| null | no |  |  | X-இல் கண்டறியப்பட்ட வீடியோக்களை ஆய்வு செய்ய முகவருக்கான அனுமதி. |
| `tools.x_search.enabled` |  | boolean | no | `false` |  | X இடுகைகளைத் தேடுவதன் மூலம் அவற்றை அணுகுதல்: true எனில், முகவர் அந்த இடுகைகளைத் தேடுவதற்காக session.tools-இல் x_search சேர்க்கப்படும்; இயல்புநிலை மதிப்பு அதை முடக்கியே வைக்கும். |
| `tools.x_search.excluded_x_handles` |  | array of string \| null | no |  | 1 – 20 items | இடுகைகள் விலக்கப்பட வேண்டிய X handle-கள்; அதிகபட்சம் 20 handle-கள். |
| `tools.x_search.from_date` |  | string \| null | no |  |  | இடுகைகளுக்கான ஆரம்பத் தேதி, ISO வடிவமான YYYY-MM-DD-இல் குறிப்பிடப்படுகிறது. |
| `tools.x_search.to_date` |  | string \| null | no |  |  | இடுகைகளுக்கான இறுதித் தேதி, ISO வடிவமான YYYY-MM-DD-இல் குறிப்பிடப்படுகிறது. |
| `enable_safety_checker` |  | boolean | no | `true` |  | அழைப்பாளர் அங்கீகரிக்கப்பட்டிருந்தால், false என அமைப்பதன் மூலம் திரையிடலைத் தளர்த்தலாம். |

File parameters (`audio`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "audio": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
}
```

A fuller example:

```json
{
  "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/xai/grok-voice?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/xai/grok-voice?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/xai/grok-voice", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "xai/grok-voice",
      "input": {
        "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "xai/grok-voice",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 1494,
    "usd": "1.494",
    "charged": 1494,
    "refunded": 0
  },
  "input": {
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3"
  },
  "output": {
    "audio": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp3",
      "content_type": "audio/mpeg",
      "file_name": "0-output.mp3",
      "file_size": 1843200
    },
    "text": "",
    "duration": 5
  },
  "outputs": [
    {
      "type": "audio",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp3",
      "content_type": "audio/mpeg",
      "file_size": 1843200,
      "duration": 12,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `audio` | object {url, content_type, file_name, file_size} | Grok முகவரிடமிருந்து கிடைக்கும் பேச்சுப் பதில், 24 kHz mono WAV ஆக வழங்கப்படுகிறது. |
| `text` | string | முகவரின் பேச்சுடன் வரும் உரை: வெற்று string எனில், Grok உரைமாற்றத்தை வழங்கவில்லை என்பதைக் குறிக்கும்; இல்லையெனில், அதில் உரைமாற்றம் இருக்கும். |
| `duration` | number | உருவாக்கப்பட்ட ஆடியோவின் நீளம், வினாடிகளில் அளவிடப்படுகிறது. |

## Related models

- [Grok Voice · Realtime](https://doitong.com/developers/models/xai/grok-voice/realtime.md) (`xai/grok-voice/realtime`): $0.00083 / second of the voice session
- [MMAudio V2](https://doitong.com/developers/models/mmaudio-v2.md) (`mmaudio-v2`): $0.001 / second
- [DeepFilterNet 3](https://doitong.com/developers/models/deepfilternet3.md) (`deepfilternet3`): $0.001 / second of input audio
- [Demucs](https://doitong.com/developers/models/demucs.md) (`demucs`): $0.0007 / second of input audio
- [ElevenLabs Audio Isolation](https://doitong.com/developers/models/elevenlabs/audio-isolation.md) (`elevenlabs/audio-isolation`): $0.10 / minute of input file
- [Elevenlabs Sound Effects V2](https://doitong.com/developers/models/elevenlabs/sound-effects/v2.md) (`elevenlabs/sound-effects/v2`): $0.002 / second
- [ElevenLabs Voice Changer](https://doitong.com/developers/models/elevenlabs/voice-changer.md) (`elevenlabs/voice-changer`): $0.30 / minute of input audio
- [FFmpeg API \[Merge Audios\]](https://doitong.com/developers/models/ffmpeg-api/merge-audios.md) (`ffmpeg-api/merge-audios`): $0.00017 / second of processing time

## Links

- HTML page: https://doitong.com/developers/models/xai/grok-voice
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=xai/grok-voice
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/xai/grok-voice
